<template>
	<v-text-field
		class="FieldsViewSearchInput"
		v-model="query"
		clearable
		placeholder="Search fields..."
		hint="by field, group, producer, or status"
		prepend-inner-icon="mdi-magnify"
		background-color="#fff"
		outlined
		dense
	/>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';

function debounce(func: Function, wait: number): any {
	let timeout: any;
	return function (...args: any) {
		const later = function (this: any) {
			timeout = null;
			func.apply(this, args);
		};
		clearTimeout(timeout);
		timeout = setTimeout(later, wait);
	};
}

export default defineComponent({
	setup(_, { root }) {
		const query = computed({
			get: () => root.$store.getters['fieldsView/getQuery'],
			set: debounce((value: string) => root.$store.dispatch('fieldsView/setQuery', value), 250),
		});

		return {
			query,
		};
	},
});
</script>

<style></style>
